#!/usr/bin/env node
import { execSync as l } from "node:child_process";
import g, { resolve as P } from "node:path";
import u, { existsSync as h, rmSync as f } from "node:fs";
import { log as r, xPrompts as c, lookForParentTarget as R, createMainCommand as S, createSubcommand as _ } from "@done-coding/cli-utils";
import { getConfigPath as b, batchHandler as D } from "@done-coding/cli-template";
import { getTargetRepoUrl as F } from "@done-coding/cli-git";
const v = {
  version: "0.10.0-alpha.0",
  name: "create-done-coding",
  description: "项目创建命令行工具",
  cliConfig: {
    namespaceDir: ".done-coding",
    moduleName: "create"
  }
}, N = "git@gitee.com:justsosu/done-coding-cli-config-json.git", j = "自定义模版路径", C = "某个git平台用户仓库", O = `./.${v.name}_temp`;
let $;
const A = async () => ($ || ($ = (await B()).templateList), $), x = async () => [
  ...await A(),
  { name: j },
  { name: C }
], I = {
  type: "text",
  name: "projectName",
  message: "请输入项目名称",
  format: (e) => e.trim(),
  validate: (e) => e.length > 0 || "项目名称不能为空"
}, L = async () => ({
  type: "select",
  name: "template",
  message: "请选择模板",
  choices: (await x()).map((t) => {
    var n;
    return {
      title: t.branch ? `${t.name}(${t.branch})` : t.name,
      value: t.name,
      description: `${t.description || ""}${(n = t.instances) != null && n.length ? `, 已应用于: ${[""].concat(t.instances).join(`
- `)}` : ""}` || void 0
    };
  }),
  validate: (t) => t.trim().length > 0 || "模板不能为空"
}), U = {
  type: "confirm",
  name: "saveGitHistory",
  message: "是否保留git历史",
  initial: !1
}, E = (e = "项目已存在，是否删除") => ({
  type: "confirm",
  name: "isRemove",
  message: e
}), H = {
  type: "text",
  name: "customUrl",
  message: "请输入自定义模板路径",
  validate: (e) => e.trim().length > 0 || "路径不能为空"
}, k = (e) => ({
  type: "text",
  name: "gitCommitMessage",
  message: "请输入git提交信息",
  initial: `feat: 初始化项目${e}`,
  validate: (t) => t.trim().length > 0 || "提交信息不能为空"
}), B = async () => {
  r.stage("拉取模板列表，请稍等...");
  const e = g.resolve(
    process.cwd(),
    O
  );
  if (h(e))
    return r.error(`${e} 已存在，请手动删除该目录再试`), process.exit(1);
  if (r.info(`配置临时目录：${e}`), u.existsSync(e)) {
    const n = `${e}目录已存在，是否删除？`, { isRemove: o } = await c(E(n));
    if (o)
      u.rmSync(e, { recursive: !0, force: !0 });
    else
      return r.error(`${e} 已存在，请手动删除该目录再试`), process.exit(1);
  }
  let t;
  try {
    l(`git clone ${N} ${e} --depth=1`);
    const n = v.name, o = g.resolve(e, `${n}.json`);
    if (t = JSON.parse(u.readFileSync(o, "utf-8")), !Array.isArray(t.templateList)) {
      const s = `远程配置文件出错, templateList 不是数组, 请检查 ${N} ${n}.json`;
      throw new Error(s);
    }
    r.success("模板列表拉取成功！");
  } finally {
    u.rmSync(e, { recursive: !0, force: !0 });
  }
  return t;
}, Y = async (e) => {
  const { projectName: t } = e, o = ((t ?? (await c(I)).projectName) || "").trim();
  if (!o)
    return r.error("项目名称不能为空"), process.exit(1);
  if (o.includes(" ") || o.includes("\\") || o.includes("/"))
    return r.error(`项目名称\`${o}\`不能包含空格或者\\或者/`), process.exit(1);
  const s = P(process.cwd(), o);
  if (h(s)) {
    const { isRemove: i } = await c(E());
    if (i === !0)
      f(s, { recursive: !0, force: !0 });
    else
      return r.error(`项目${o}已存在`), process.exit(1);
  }
  const { template: m } = await c(await L());
  let p = "", d = "";
  if (m === j) {
    const { customUrl: i } = await c(H);
    p = i;
  } else if (m === C)
    p = await F();
  else {
    const i = (await x()).find(
      (a) => a.name === m
    );
    if (!i)
      return r.error(`模板${m}不存在`), process.exit(1);
    if (!i.url)
      return r.error(`模板${m}仓库地址不存在`), process.exit(1);
    p = i.url, d = i.branch;
  }
  const y = R(".git");
  r.stage("正在初始化项目，请稍等..."), l(
    `git clone${d ? ` -b ${d}` : ""} ${p} ${o} --depth=1`,
    { stdio: "inherit" }
  );
  const w = b(s);
  if (w && (await D({
    rootDir: s,
    extraEnvData: {
      $projectName: o
    }
  }), f(w, { force: !0 }), r.stage("模板项目配置注入成功, 模版项目配置文件已删除")), r.stage("项目初始化完成"), y) {
    const i = g.resolve(s), a = g.resolve(i, ".git");
    if (!h(a))
      throw new Error("git目录不存在");
    f(a, { recursive: !0, force: !0 }), r.stage(
      `项目创建在父级git仓库${y}中，已删除${o}目录下的.git(${a})`
    );
  } else if ((await c(U)).saveGitHistory)
    l("git remote rename origin upstream && git fetch --unshallow", {
      cwd: s,
      stdio: "inherit"
    }), r.stage(
      "已经将origin重命名为upstream，后续可以与模板git仓库有完整的交互"
    ), r.success("已保存git历史记录");
  else {
    const a = g.resolve(s, ".git");
    f(a, { recursive: !0, force: !0 }), l("git init", {
      cwd: s,
      stdio: "inherit"
    });
  }
  const { gitCommitMessage: M } = await c(
    k(o)
  );
  l(`git add . && git commit -m '${M}'`, {
    cwd: s,
    stdio: "inherit"
  }), r.success(`项目${o}初始化完成`), r.info(`
使用步骤: 
  1. cd ${o}
  2. pnpm install
  3. pnpm run dev
  `);
}, {
  version: J,
  description: q,
  cliConfig: { moduleName: z }
} = v, G = {
  describe: q,
  version: J,
  positionals: {
    projectName: {
      describe: "项目名称",
      type: "string"
    }
  },
  handler: Y
}, T = (e = !1) => {
  const t = `${e ? `${z} ` : ""}[projectName]`, n = `$0 ${t.trim()}`;
  return { command: t, usage: n };
}, ee = async () => S({
  ...G,
  ...T()
}), te = () => _({
  ...G,
  ...T(!0)
});
export {
  te as a,
  ee as c,
  Y as h
};
